#!/bin/perl

use Data::Dumper; #JET_DEBUG
require HTML::TokeParser;
use URI;
use LWP;

$MY_DEBUG=1; #JET_DEBUG
$MY_DEBUG=2; #JET_DEBUG
$MY_DEBUG=0; #JET_DEBUG
##
### jetver -  a program to check current program versions against
##            program versions found on the internet or local file system.
###
##          if you get your software from some repository, use their method.
##	    if you know exactly what you want, use  lwp-download http://www.perl.com/CPAN/src/latest.tar.gz
##          if you get it from the authors, this is for you.

#    Copyright (C) 2009  John E. Tysko
#        email to tysko@eecs.ohiou.edu
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#
##
### John Tysko, Tue Jul 21 11:48:20 EDT 2009
###
### Version 3.0.1
###
###   comments may be vague - this is also the design document, updated on the fly.
###
### requres perl modules    LWP::Simple; HTML::TokeParser; URI;
###
### params - [options] {current-filename-name}  url   {     -     } [version_patterns ...]  file_pattern
###                            {--}                   {type-of-url} 
###
###   -or-   [options]   {-inputfile | -i } [-src SOURCE_DIR ] location_file_name   [MATCH_KEY]
###            
##
##		options -   -noalpha = ignore any version with "alpha" (case insensative) in version.
##		            -nobeta  = ignore any version with "beta" (case insensative) in version.
##			    -quiet (or -q)  do not complain if we can not find software package in
##					local directory. Should be useful to run against standard
##					example distribution file.
##			    -get = get the eventual target file, download to current directory
##					Results of multiple identical versions with different
##					suffixes may be unpredictable. Will download file even if no
##					file src is present on current system
##			    -get=FILENAME - FILENAME is name of the file to save the downloaded file in.
##					Otherwise, use actual name. WILL download file even if no file
##					src is present on current system
##			    -get_newer = get the eventual target file, download to current directory,
##			    -getnewer	 only if file is atually newer current name. If local file does not
##					exist, will not download. Results of multiple identical versions
##					with different suffixes may be unpredictable
##			    -get_newer=FILENAME - FILENAME is name of the file to save the downloaded file in.
##					Otherwise, use actual name.
##					If local file does not exist, will not download
##			    -v          Verbose - reverses -q and adds additional verbage.
##			    -exact      Skip the extra helper code to see if a pattern matches.
##					1. Skip the check to see if a pattern specified as a search pattern
##					   would match a patthen in the URL if it had a "/" appended.
##   First form
##		current-filename-name- actual name of the file, as in jetver-0.29.tar.gz
##                      or -- denoting final file name is defined by pattern matches
##		url -The url of where the file is located, as in 
##			http://some.server.org/jetver
##			ftp://ftp.server.org/pub/src/jetver/@/
##			where each @ represents a pattern to match for versioning checking.
##			Final file name assumed on last page down. so that 
##			output of ftp://ftp.server.org/pub/src/jetver/@ may have dirs
##				1.0
##				2.0
##			and directory 2.0 would have files matching final pattern. 
##			There must be 1 more pattern specified than @ in the url.
##			always assume the largerst ver num is newest, and look only
##			in newest dir and only return newest file name.
##			file://some.dir/file  Yep. It can work, 
##		type-of-url = "-"  deduce format of page returned by query form url itself.
##				 ftp://... is an ftp type listing,
##				 http://... return html, etc
##				 file://... assume a dirctory in local file system
##			      Specify the type explicily when data returned is not what the url indicates
##					(as in some active web pages, or curently unrecognized types)
##		              "general" - we can find the pattern anywhere on the page.
##				url will be a web page or http to a ftp server or...
##				must have trailing / to get directory lookup if ftp.
##				must end in .html or .htm or whatever for web page.
#				can contain @ symbol to show version patthens included.
##			      "ftp"  - assume directory or program will be in last column.
##				as output from ls -la   or  ftp:// url would look like.
##			      "html" -or- "http" - web page, with embedded html to make things interesting.
##					@ references may be either directory/file names or description names.
##			      "file" - url points to a file, pattern matches serial no within file.
##					Useful for things like jetver examples file.
##		version_pattern - character string of intermediate directory name
##				to use for version numbers. Assumed superior to version numbers
##				in file. The version replaces the @ in url, using following patterns
##				successively as actual patterns to match for that wild card.
##			such as target directory as in  ftp://ftp.server.org/pub/src/jetver/@/ 
##						the pattern would be @@
##			html pages can specify pattern for either href= part of reference, or 
##				the text for the reference. For example, if the http code is:
##					<a href=./rel_dir-0.43> Release 0.43 </a>
##				the pattern "rel_dir-@=@"  or  "Release @=@" would match.
##		file_pattern - only pattern not specified with a @ in url, this pattern is the pattern
##			of the file itself. It must be present and it always used to scan the
##			lowest level of tree specified by url, so no pattern indicator is needed
##			in the url. Using the pattern @@ will work,but may give unexpected  results if
##			 web pages are searched, or results archives of multiple packages are found,
##			or random files are present such are REAME files.
##			example:  jetver-0.29.tar.gz uses pattern  jetver-@@.tar.gz
##                                but also match jetver-doc-0.29.tar.gz. Using the pattern @=@
##				  forces the first character of the version to be numeric so:
##				   jetver-@=@.tar.gz only matches jetver-0.29.tar.gz, not jetver-doc-0.29.tar.gz.
##    Second form
##			    -inputfile (or -i)  - signifies that next parameter is a file name containing
##					the locations of the packages on the net. ( the data otherwise
##                                      passed via command line. 
##					Data file format is:
##					 Lines startting with # are comments.
##					 Any text before a lone '@' is a descriptoin field, and is ignored.
##					 command line parameters, 1 program per line, follow, white space separated.
##			    -src  - use the directory SOURCE_DIR as the directory that contains the archive files to 
##                                      be checked to see if they are current. Nice way to dump the contents of a
##                                      CD or archive and check if all software is up to date. If no files match the
##                                      file match key in the inputfile, no checking for a current version is done.
##                                      This lets you use the provided example file without a lot of false lookups.
##			    MATCH_KEY = optional parameter used to perform a simple match against the description field. 
##					The first n characters are matched (n being the number of characters in MATCH_KEY)
##					and only those lines are processed. If no key is specified, all lines are processed.
##
##  example:   pango  =  pango-1.20.5.tar.gz ftp://ftp.gtk.org/pub/pango/@/ ftp  @@ gtk+-@@.tar.gz

##   SPECIAL NOTES ON PATTERN MATCHING FOR VERSION NUMBERING
### Take web pages or ftp directory listings from the web,
### get environment variable PAT that contains pattern to look for
###  in form   ANYTHING@@ANYTHING2
##     where ANYTHING and ANYTHING are any string of characters,
##             assumed constants.
##     @@ is the literal @@ denoting a placeholder for version info.
##        Versions are assumed to to follow more or less standard formats
##        such as ###-###-## possibly with 
##        non-digits mixed in, as in openssl-0.9.8j.tar.gz - the version
##        is 0.9.8j which is matched by openssl-@@.tar.gz
##     @=@ is a special form that forces a leading digit in the version
##                  such as 13.2 and not alpha-12.2
##     @==@ is a special form that forces a leading digit and trailing digit in the version
##                  such as 13.2.4 Useful for descriminating pkg-2.3.tar.gz from pkg-2.3-lib.tar.gz
##			or pkg-2.3-2.4.diff.tar.gz
##     @##@ is a special form that forces only digits and a choice of 3 level separators  ".-_"
##          gets rid of things like  3.4.2RC5  that @==@ will not.
##     @==A@ forces a leading digit, and ending in a digit followed by an (optional) letter. 
##            Nice for versions by year with a subversion of a trailing letter.
##            Or 0.9.8j which is matched by openssl-@@.tar.gz, but more specifically as openns-@==A@.tar.gz
## 	      Also matches a version number such as  3b  or 2a.
##     @TZ@ - not part of version number, or literal part of the file name,
##		but when used as the last 4 characters in a pattern, it will
##		match combinations of tar, cpio, etc with comprssion suffixes such
##		as gz, bz2 etc. Use this to avoid the trap
##		of the archive site changeing comression methods between releases.
##              pkg-@==@.@TZ@ matches pkg-12.tar.gz and pkg-13.tar.bz2. 
##    @URL@ - not part of version number, or literal part of the pattern name,
##		but when used as the first 5 characters of the pattern name,
##		specifies that the current pattern will be found 
##		as a part of a url in the html page on the server. The @URL@ pattern is
##		removed for matching on the local machine to determine the 
##		current version number, and is used to match the contents of urls
##		specified on the web page starting after the last "/" (or the entire url)
##		Only is meaningful on html pages, just ignored for other types
##		For example, for the latest release of SpamAssassin, the local source
##		directory /usr/local/mail/spamassassin might contain Mail-SpamAssassin-3.1.9.tar.bz2
##		Download directory name changes with releases, and also uses general names 
##		such as "SpamAssassin(tm) in tar.gz". The actual link to the current file
##              is in a url such as:
## <a href="http://apache.tradebit.com/pub/spamassassin/source/Mail-SpamAssassin-3.2.5.tar.gz">SpamAssassin(tm) in tar.gz</a>
##		so we need a search pattern to look like: (remember, final file pattern match not specified in url)
##		@/usr/local/src/mail/spamassassin http://spamassassin.apache.org/@ - @Download@ @URL@Mail-SpamAssassin-@==A@.@TZ@
##    @URL+@ - Similar ot @URL@, not part of version number, or literal part of the pattern name,
##		but when used as the first 6 characters of the pattern name,
##		specifies to search both the URL and the text tag on the web pages
##		Only is meaningful on html pages, just ignored for other types

##     Alternately, anything else placed between the two @ will be used as
##     a forced pattern match instead of the others specified above.
##     Examples:
##	  Standard match:
##		jetver.@.*@.tar.gz  is the same as jetver.@=@.tar.gz
##	  Numeric first match
##		jetver.@[0-9].*@.tar.gz  is the same as jetver.@=@.tar.gz 
##	  Numeric first and last match
##		jetver.@[0-9].*[0-9]@.tar.gz  is the same as jetver.@==@.tar.gz
##	  gtk++ match on even releases only (stable, no development)
##		url would be ftp://ftp.gnome.org/pub/GNOME/sources/gtk+/@/ 
##		pattern 1 would be:  @.*[02468]@  matching any file/directory that is even 
##		pattern 2 would be:  gtk+-@@.tar.bz2 matching the actual bzip2 file

### version info from string is in the form:
###        nnn{[^0123456789]*{nnn}}*   
###            where nnn is number, leading zeros ok.
##			1 is earlier than 10 (numeric type versions)
##             {[^0123456789] any of these delimiters between major/minor vers
##			A is assumed earlier than AA
##		{nnn} - optional trailing numeric string.
##             {}  repeat subversions as necessary.
##        assume versions with extra level of versioning is newer than
##        versions with lesser, as long as the higher levels of version
##        match. Assume 9 places of version numbering for each lever of
##	  versioning, either numeric or non-numeric.


use LWP::Simple;
use LWP; ## ok, new way
$BROWSER = LWP::UserAgent->new;





## INIT ARCHIVE/COMPRESSION suffixes here
@suffixes_archive=('tar', 'gtar' , 'shar' , 'cpio');
@suffixes_compress_noarchive=('Z', 'gz' , 'bz2' , 'zip', 'ZIP', 'qz', 'lzma', 'lz', '7z');
$suf_index=0;
foreach $i ( @suffixes_archive ) { ## do multiple first to avoid strange matches.
	$suffixes_all_match[$suf_index++] = $i . '$';
	foreach $j (@suffixes_compress_noarchive) { 
		$suffixes_all_match[$suf_index++] = $i . '\.' .  $j . '$';
	}
}
foreach $j (@suffixes_compress_noarchive) {   $suffixes_all_match[$suf_index++] = $j . '$';}
foreach $i ( @suffixes_archive ) { $suffixes_all_match[$suf_index++] = $i . '$'; }
$suffixes_all_match[$suf_index++] = 'tgz$';


###
## process options here, if any
###

$VERBOSE=0;
$FORCE_SEARCH = 0; #JET_DEBUG
$FORCE_SEARCH_USER = 0;  ## used to allow get of file even if we do not have a local copy.
$INPUT_FILE="";
$NOBETA=0;
$NOALPHA=0;
$DROP_TRAILING_SLASH = 1;  ## if true, drop trailing "/" on found token in case it specifies diregory name.
$PRINT_NO_LOCAL_PKG=1;
$GET_FILE=0; $GET_NEW_FILE_ONLY=0; $GET_FILE_NAME="";
$NO_CURRENT_FILE=0; ## if true, we have -- intead of current file name
while (substr($ARGV[0],0,1) eq "-" && substr($ARGV[0],0,2) ne  "--") {
	$option = shift(@ARGV);
	if ($MY_DEBUG) { print "CHECKING OPTION $option\n";} #JET_DEBUG
	if ($option =~ /^-nobeta$/i ) { $NOBETA = 1; }
	elsif ($option =~ /^-noalpha$/i ) { $NOALPHA = 1; }
	elsif ($option =~ /^-quiet$/i || $option =~ /^-q$/i  ) { $PRINT_NO_LOCAL_PKG=0; } 
	elsif ($option =~ /^-debug$/i || $option =~ /^-d$/i ) { $MY_DEBUG++; } #JET_DEBUG
	elsif ($option =~ /^-force$/i || $option =~ /^-f$/i ) { $FORCE_SEARCH++; } #JET_DEBUG
	elsif ($option =~ /^-exact/i ) {
		$DROP_TRAILING_SLASH = 0; ## no second chances if found name ends in slash
		if ($MY_DEBUG) { print "OPTION exact - no check to see if dropping endning / makes a match \n";} #JET_DEBUG
	}
	elsif ($option =~ /^-help/i || $option =~  /^-h$/i) {
		print_help();
		exit;
	} elsif ($option =~ /^-v/ ) { 
		$VERBOSE=1;
	} elsif ($option =~ /^-get/i ) { 
		$GET_FILE=1;
		$FORCE_SEARCH_USER = 1;
		if ($MY_DEBUG) { print "OPTION - get file - do not check for local file.\n";} #JET_DEBUG
		if ($option =~ /^-get=/i) { 
			$FORCE_SEARCH_USER = 1;
			$GET_FILE=2;
			$GET_FILE_NAME= substr($option,5);
			if ($MY_DEBUG) { print "OPTION - get file = $GET_FILE_NAME \n";} #JET_DEBUG
		}
		if ($option =~ /^-get_newer/i ) {
			if ($MY_DEBUG) { print "OPTION - get newer file\n";} #JET_DEBUG
			$GET_NEW_FILE_ONLY=1;  ## only get file only if newer.
			if ($option =~ /^-get_newer=/i) { 
				$GET_FILE=2;
				$GET_FILE_NAME= substr($option,10);
				if ($MY_DEBUG) { print "OPTION - get newer file = $GET_FILE_NAME \n";} #JET_DEBUG
			}
		}
		if ($option =~ /^-getnewer/i ) { ##alias for get_newer
			if ($MY_DEBUG) { print "OPTION - get newer file\n";} #JET_DEBUG
			$GET_NEW_FILE_ONLY=1;  ## only get file only if newer.
			if ($option =~ /^-getnewer=/i) { 
				$GET_FILE=2;
				$GET_FILE_NAME= substr($option,10);
				if ($MY_DEBUG) { print "OPTION - get newer file = $GET_FILE_NAME \n";} #JET_DEBUG
			}
		}
		if ($option =~ /^-get_new/i ) {   ###Yeah, alias for get_newer
			$GET_NEW_FILE_ONLY=1;  ## only get file only if newer.
			if ($option =~ /^-get_new=/i) { 
				$GET_FILE=2;
				$GET_FILE_NAME= substr($option,10);
			}
		}
		if ($option =~ /^-getnew/i ) {   ###Yeah, alias for get_newer
			$GET_NEW_FILE_ONLY=1;  ## only get file only if newer.
			if ($option =~ /^-getnew=/i) { 
				$GET_FILE=2;
				$GET_FILE_NAME= substr($option,10);
			}
		}
		
	} elsif  ($option =~ /^-inputfile$/i || $option =~ /^-i$/i ) { ## FORMAT 2
		if ($MY_DEBUG) { print "OPTION inputfile  check... \n";} #JET_DEBUG
		$INPUT_FILE = shift(@ARGV);
		$INPUT_FILE_PATTERN="";
		$INPUT_FILE_PATTERN_LEN=0;
		$INPUT_FILE_DIR_OVERRIDE="";
		if ($#ARGV >= 0 && $ARGV[0] eq "-dir") {
			shift(@ARGV);
			$INPUT_FILE_DIR_OVERRIDE = shift(@ARGV);
		}

		if ($#ARGV >= 0) { $INPUT_FILE_PATTERN = shift(@ARGV);
				   $INPUT_FILE_PATTERN_LEN=length($INPUT_FILE_PATTERN);
				   if ($#ARGV >= 0) { 
					print "Error - illegal option $option - terminating\n";
					print_help();
					exit;
				}
			}
	} else {
		print "Error - illegal option $option - terminating\n";
		print_help();
		exit;
	}
}



###############
##############   Main control loop - either 1 time for command line options,
##############    or n times for input from a file.
###############

if ($INPUT_FILE eq "") {
	if ($MY_DEBUG) { print "Using comand line input\n";} #JET_DEBUG
	@ARG_ARRAY = @ARGV;
	$PGK_COMMENT="";
	execute_search();
} else {
	if ($MY_DEBUG) { print "Using file $INPUT_FILE for packages, not command line\n";} #JET_DEBUG
	if ($MY_DEBUG) { if ($INPUT_FILE_PATTERN_LEN == 0) {print "  no per line pattern matching will be done...\n";}} #JET_DEBUG
	if ($MY_DEBUG) { if ($INPUT_FILE_PATTERN_LEN > 0) {print "  Per line pattern matching will be $INPUT_FILE_PATTERN of length $INPUT_FILE_PATTERN_LEN  \n";}} #JET_DEBUG
	if ($MY_DEBUG) { if ($INPUT_FILE_DIR_OVERRIDE ne "") {print "  source directory override is $INPUT_FILE_DIR_OVERRIDE...\n";}} #JET_DEBUG
	if ($GET_FILE > 1) {
		if ($MY_DEBUG) {print "  -get option specified with name and input file for packages - ignoring $GET_FILE_NAME\n";} #JET_DEBUG
		$GET_FILE = 1;
	}
	open PARM_FILE, $INPUT_FILE  || die "Input file $INPUT_FILE is unavailable";
	my @arg_file = <PARM_FILE>;
	close PARM_FILE;
	foreach $parm_index ( @arg_file) {
		chomp $parm_index;
		if ($MY_DEBUG > 2) { print "data file line is -->$parm_index\n";} #JET_DEBUG
		if ($parm_index =~ m/^[ \t]*\#/ ) {
			if ($MY_DEBUG>2 ) { print "skipping comment line -->$parm_index\n";} #JET_DEBUG
			next;}
		if ($INPUT_FILE_PATTERN_LEN > 0 ) {
			if ($MY_DEBUG>2 ) { print "Trying for key match...\n";} #JET_DEBUG
			if ( substr($parm_index,0,$INPUT_FILE_PATTERN_LEN) eq $INPUT_FILE_PATTERN ) {
				if ($MY_DEBUG>2 ) { print "MATCHING key on line -->$parm_index\n";} #JET_DEBUG
			} else {
				if ($MY_DEBUG>2 ) { print "non-matching key for -->$INPUT_FILE_PATTERN<-- - skipping line -->$parm_index\n";} #JET_DEBUG
			next;}
		}
		if ($parm_index =~ m/[ \t]+@[ \t]+/ ) {
			$PGK_COMMENT = $parm_index;
			$PGK_COMMENT =~ s/[ \t]+@[ \t]+.*//;
			$parm_index =~ s/.*[ \t]+@[ \t]+//;
			@ARG_ARRAY= split(' ', $parm_index);
			 if ($INPUT_FILE_DIR_OVERRIDE ne "") { $ARG_ARRAY[0] = "@" . $INPUT_FILE_DIR_OVERRIDE;}
			execute_search();
		} else {
			if ($MY_DEBUG ) { print "skipping line with no @ delim -->$parm_index\n";} #JET_DEBUG
		}
	}
}

exit; ##ok, were done here



#### code to do one package lookup. setting from global

sub execute_search() {
if ($MY_DEBUG) { print "\n\n   >>> enter sub execute_search        \n";} #JET_DEBUG
	$current_file_name = $ARG_ARRAY[0];  ## note - may be "--" if we use final name pattern
	if ($current_file_name eq "--" ) {
		$NO_CURRENT_FILE=1;
		$current_file_name = $ARG_ARRAY[$#ARG_ARRAY];
		if ($MY_DEBUG) { print "current file name is -- using $current_file_name instead.\n"; } #JET_DEBUG
	}

	$get_url = $ARG_ARRAY[1];
	
	$PARM_GET_URL_TYPE =  $ARG_ARRAY[2];
	if ( $get_url_type =~ /http/i || $get_url_type =~ /html/i) {$get_url_type="html";}
	if ( $get_url_type =~ /general/i ) {$get_url_type="general";}
	if ( $get_url_type =~ /ftp/i ) {$get_url_type="ftp";}
	if ( $get_url_type =~ /file/i ) {$get_url_type="file";}
	
	$get_patterns_needed = ($get_url =~ tr/\@//)+1;
	if (($#ARG_ARRAY-2) != $get_patterns_needed) {
		print "error - need $get_patterns_needed  patterns for $get_url but have " . ($#ARG_ARRAY -2) . " for  : \n";
		print "Current package reference: $current_file_name\n";
		print "URL to reference: $get_url\n";
		print "Type of url: $PARM_GET_URL_TYPE\n";
		for ( $i = 3; $i<= $#ARG_ARRAY; $i++) { print $ARG_ARRAY[$i] . "\n";}
		return;
	}
	@get_patterns =  @ARG_ARRAY[3 .. $#ARG_ARRAY];
	
	
	## option done, parm loaded. See if we need to get current pgm version from local directory.
	
	$GET_URL_TYPE = "local_ls";  ## fake it for dir listing
	$GET_THIS_URL = $current_file_name ; ##  fake it for dir listing
	if (substr($current_file_name,0,1) eq "@") {  ## we do.
		if ($MY_DEBUG) { print "getting latest file from $current_file_name \n";} #JET_DEBUG
		$filedir = substr($current_file_name,1) . "*"; 
		$filedir = substr($current_file_name,1); 
		if ($MY_DEBUG) { print "        searching directory $filedir  \n";} #JET_DEBUG
		unless (opendir(DIR, $filedir) ) {
			if ($MY_DEBUG) { print "Open failed for dir $filedir. See if $current_file_name is a file \n";} #JET_DEBUG
			if(open(FILE, "<$filedir") ) {
				@lines_to_search =<FILE>;
				close (FILE);
				if ($MY_DEBUG) { print "read $#lines_to_search from file. \n";} #JET_DEBUG
				$GET_URL_TYPE = "local_other";  ## oops. file.
			} else {
				if ( $FORCE_SEARCH_USER ) {  #download override.
					if ($MY_DEBUG) {print "Force ignore no local copy of file....\n";} #JET_DEBUG
					$skip_dir_not_found=0;
					@lines_to_search = ("");;
					$CURRENT_VERSION="";
					$FIND_NEWEST_ANS{'found_cnt'} =1;
					return();
				} else {
					if ( $PRINT_NO_LOCAL_PKG) {print "Unable to open directory or file $filedir\n";}
					if ( $FORCE_SEARCH ) { #JET_DEBUG
						print "FORCE is a MY_DEBUG type option only....\n"; #JET_DEBUG
						print "Current directory for $PGK_COMMENT not found:  assuming version 0  "; #JET_DEBUG
						$skip_dir_not_found=0;  #JET_DEBUG
						@lines_to_search = ("");;  #JET_DEBUG
						$CURRENT_VERSION="";  #JET_DEBUG
					} else { #JET_DEBUG
					return();
					} #JET_DEBUG
				}
			}
		}
		if ($GET_URL_TYPE eq "local_ls" ) { ## ok, if we didnt find it as a file, must be dir.
			@lines_to_search =readdir(DIR);
			if ($MY_DEBUG) { print "read $#lines_to_search from dir. \n";} #JET_DEBUG
			closedir (DIR);
		}
	} else {
		@lines_to_search = ($current_file_name);
	}
	
	$PAT = $get_patterns[$#get_patterns];
	$OUTPUT_CURRENT_FILE =  $PAT ; ## output pattern name when no local file found.
	if ($MY_DEBUG) { print "---lines to search---\n";  if ($NO_CURRENT_FILE) { print " SPECIFIED BY --\n";}; for $out (@lines_to_search) { print $out . "\n"; }} #JET_DEBUG
	find_newest();
	if ( $MY_DEBUG > 1) {print Dumper(%FIND_NEWEST_ANS); print "\n\n";} #JET_DEBUG
	
	if ($FIND_NEWEST_ANS{'found_cnt'} > 0) {
		$OUTPUT_CURRENT_FILE =  $FIND_NEWEST_ANS{"filename"}->[0];;
		$CURRENT_VERSION=$FIND_NEWEST_ANS{'version'};
		if ($MY_DEBUG) { print "Current version is " .  $CURRENT_VERSION . " for file " . $FIND_NEWEST_ANS{"filename"}->[0] . " \n";} #JET_DEBUG
		if ($VERBOSE && ! $FORCE_SEARCH_USER) { ## print names of local files found if verbose and not forced downld
			print "Current entry for  $PGK_COMMENT found: ";
			for ($i=0; $i<$FIND_NEWEST_ANS{'found_cnt'} ; $i++) {
				print  "    " . $FIND_NEWEST_ANS{"filename"}->[$i] . "\n" ;;
			}
		}
	} else {
		$OUTPUT_CURRENT_FILE =  "** No local file for " . $OUTPUT_CURRENT_FILE;
		if ( $FORCE_SEARCH_USER ) {  #download override. - do a get no matter what
			if ($MY_DEBUG) {print "Force ignore no local copy of file....\n";} #JET_DEBUG
			$skip_dir_not_found=0;
			@lines_to_search = ("");;
			$CURRENT_VERSION="";
		#	$FIND_NEWEST_ANS{'found_cnt'} =1;
		} elsif ($INPUT_FILE_DIR_OVERRIDE eq "" && $INPUT_FILE eq "") {  ## show msg not found unless we have src dir specified.
			if ( $PRINT_NO_LOCAL_PKG) { print "  NO current entry found - skipping check \n";} 
			return();
		} 
## probably too much info... 
		if ($PRINT_NO_LOCAL_PKG ) { ## print no file found UNLESS we do a get.
			if ( $PGK_COMMENT == "") {
				print "Current entry not found:  assuming version 0.\n";
			} else {
				print "Current entry for $PGK_COMMENT not found:  assuming version 0\n";
			}
		}
		$CURRENT_VERSION="";
	} 
	
	
	if ($MY_DEBUG) { print "\n\n-----------------------------\n--------------------------------------\n";} #JET_DEBUG
	if ($MY_DEBUG) { print "   now look for file with version greater than " .  $CURRENT_VERSION . " \n";} #JET_DEBUG
	if ($MY_DEBUG) { print "\n-----------------------------\\n--------------------------------------n\n";} #JET_DEBUG
	
	###
	### master loop to go through the url, looking at 1 level at a time for newest page, then
	### grab actual result. Of course, web pages that hop-skip-jump thru the www are a pain...
	###
	
	$OUTPUT_URL_FAILED = "";
	for ($pattern_index=0; $pattern_index <$get_patterns_needed && $output_url_failed eq ""; $pattern_index++) {
	
		$GET_THIS_URL = $get_url;
		if ($PARM_GET_URL_TYPE eq "-" ) {
			if ($GET_THIS_URL =~ /^http/i ) { $GET_URL_TYPE = "html" ;}
			elsif ($GET_THIS_URL =~ /^ftp/i ) { $GET_URL_TYPE = "ftp" ;}
			else { $GET_URL_TYPE = "general" ;}
		} else {
			$GET_URL_TYPE = $PARM_GET_URL_TYPE ;
		}
		if ($MY_DEBUG) { print "\n\n >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> \n";} #JET_DEBUG
		if ($MY_DEBUG) { print ">>>>>>>>>>>>>>>>   MASTER LOOP  \n";} #JET_DEBUG
		if ($MY_DEBUG) { print ">>>>>>>>>>>>>>>>    URL-->$GET_THIS_URL<-- \n";} #JET_DEBUG
		if ($MY_DEBUG) { print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> \n";} #JET_DEBUG
		if ($MY_DEBUG) { print "\n\n-input parameter url type show -->$PARM_GET_URL_TYPE<-- and using -->$GET_URL_TYPE<--\n";} #JET_DEBUG
		if ($MY_DEBUG) { print "\n\n----------------------\n--------------------------------------\n";} #JET_DEBUG
		if ($MY_DEBUG) { print "----------------------\n--------------------------------------\n\n";} #JET_DEBUG
		if ($MY_DEBUG) { print "   now get wild card number $pattern_index of $get_patterns[$pattern_index]  with url " .  $GET_THIS_URL . " \n";} #JET_DEBUG
		if ($MY_DEBUG) { print "\n----------------------\n--------------------------------------\n";} #JET_DEBUG
		if ($MY_DEBUG) { print "\n----------------------\n--------------------------------------\n\n";} #JET_DEBUG
		$PAT = $get_patterns[$pattern_index];
		if ( $pattern_index != $#get_patterns) {  ## drop lower level here 
		 	$GET_THIS_URL =~ s'/[^/]*\@.*'';  ## drop trailing / - bad url if we get    http://host/page.html/
		 	$GET_THIS_URL =~ s'\@.*''; 
			if ($MY_DEBUG) { print "***************************************************************** \n";} #JET_DEBUG
			if ($MY_DEBUG) { print "getting url $GET_THIS_URL with pattern $PAT of type $GET_URL_TYPE \n";} #JET_DEBUG
			if ($MY_DEBUG) { print "***************************************************************** \n";} #JET_DEBUG
##old way			$url_data = get $GET_THIS_URL;
			$RETURNED_THIS_PAGE = $BROWSER->get ($GET_THIS_URL);
			if ($MY_DEBUG > 3 ) {print "***\n** dump of returned url data \n" .  Dumper($RETURNED_THIS_PAGE) . "\n";} #JET_DEBUG
			if (!$RETURNED_THIS_PAGE->is_success) {
				 if ($MY_DEBUG) {print "***\n** URL has no resonse - \n****" . $RETURNED_THIS_PAGE->status_line . " *******\n";} #JET_DEBUG
				$OUTPUT_URL_FAILED = $RETURNED_THIS_PAGE->status_line;
				next;
			}
			$url_data = $RETURNED_THIS_PAGE->content;
			if ($MY_DEBUG) {print "*   We have retried page of type " . $RETURNED_THIS_PAGE->content_type . " ****\n";} #JET_DEBUG
			if ($RETURNED_THIS_PAGE->content_type eq 'text/html') {
				$GET_URL_TYPE =  "html";
			} elsif ($RETURNED_THIS_PAGE->content_type eq 'text/ftp-dir-listing' ) {
				$GET_URL_TYPE = "ftp";
			} elsif ($RETURNED_THIS_PAGE->content_type eq 'text/plain' ) {
				$GET_URL_TYPE = "file";
			} else {  $GET_URL_TYPE = "general" ; }
			if ($MY_DEBUG) {print " content type of " . $RETURNED_THIS_PAGE->content_type . " mapped to $GET_URL_TYPE \n";} #JET_DEBUG


## we used to , but I think this is ok now..
#			if (!defined ($url_data) &&  $GET_URL_TYPE eq "ftp" ) {
#				$get_this_url_2 = $GET_THIS_URL;
#				$get_this_url_2 =~ s/\//\%2F/g; ## change all / to hex value, but ftp://xx/ get changed too.
#				$get_this_url_2 =~ s/\%2F/\//; ## change to ftp:/%2Fxx%2F get changed too.
#				$get_this_url_2 =~ s/\%2F/\//; ## change to ftp://xx%2F get changed too.
#				$get_this_url_2 =~ s/\%2F/\//; ## change to ftp://xx/ get changed too.
#				if ($MY_DEBUG) { print "*******\n******** URL undefined, retry as $get_this_url_2\n***********\n";} #JET_DEBUG
#				$url_data = get $get_this_url_2;
#			}
			if ($GET_URL_TYPE eq "ftp" | $GET_URL_TYPE eq "general" | $GET_URL_TYPE eq "file" ) { ## split early if no want html.
				@lines_to_search = split ('\n',$url_data);
			}
			find_newest(); ## answer returned in $FIND_NEWEST_ANS
			if ($MY_DEBUG) { print "find newest answer returned is  \n " . Dumper(%FIND_NEWEST_ANS); print "\n";} #JET_DEBUG
			if ($FIND_NEWEST_ANS{'found_cnt'} == 0 ) {
				print "### unable to find match in $GET_THIS_URL\n";
			} else {
				$found =$FIND_NEWEST_ANS{"filename"}->[0];
				$found_new =$FIND_NEWEST_ANS{"new_url"};
				if ($MY_DEBUG) { print "   found matching pattern =  $found \n";} #JET_DEBUG
				if ($MY_DEBUG) { print "   via returned new url of $found_new.\n";} #JET_DEBUG
				if ($MY_DEBUG) { print "   now alter url of $get_url ";} #JET_DEBUG
				if ($GET_URL_TYPE eq "html" ) {
					if ($MY_DEBUG) { print " (html type) ";} #JET_DEBUG
					if (substr($FIND_NEWEST_ANS{'new_url'},-1,1) eq '/') {  ##oops, ending slash. ditch.
						if ($MY_DEBUG) { print " note - needed to drop trailing slash frrom url.\n ";} #JET_DEBUG
						$FIND_NEWEST_ANS{'new_url'} = substr($FIND_NEWEST_ANS{'new_url'},0,
									length($FIND_NEWEST_ANS{'new_url'})-1);
					}
			### html returns new url to atual page we want to go to. this may or may be be the same as
			### the current page with the 2 replaced by file name.
		### - hmmm, I think this is real bad			$get_url =~ s/[^@]*@/$FIND_NEWEST_ANS{'new_url'}/;
		#### dumb				$get_url =~ s/\@/$found/;
					$get_url =~ s/[^\@]*\@/$FIND_NEWEST_ANS{'new_url'}/;
				} else {
					if ($MY_DEBUG) { print " (non-html type) ";} #JET_DEBUG
					$get_url =~ s/\@/$found/;
				}
				if ($MY_DEBUG) { print " URL is $get_url\n";} #JET_DEBUG
			}
		} else {  ### last pattern match done. now we do actual version matching pattern
			if ($MY_DEBUG) { print "***************************************************************** \n";} #JET_DEBUG
			if ($MY_DEBUG) { print "using same URL $GET_THIS_URL  \n";} #JET_DEBUG
			if ($MY_DEBUG) { print "getting last pattern url $GET_THIS_URL with pattern $PAT \n";} #JET_DEBUG
			if ($MY_DEBUG) { print "***************************************************************** \n";} #JET_DEBUG
## old			$url_data = get $GET_THIS_URL;
			$RETURNED_THIS_PAGE = $BROWSER->get ($GET_THIS_URL);
			if ($MY_DEBUG > 3 ) {print "***\n** dump of returned url data \n" .  Dumper($RETURNED_THIS_PAGE) . "\n";} #JET_DEBUG
			if (!$RETURNED_THIS_PAGE->is_success) {
				 if ($MY_DEBUG) {print "***\n** URL has no resonse - \n****" . $RETURNED_THIS_PAGE->status_line . " *******\n";} #JET_DEBUG
				$OUTPUT_URL_FAILED = $RETURNED_THIS_PAGE->status_line;
				next;
			}
			$url_data = $RETURNED_THIS_PAGE->content;
			if ($RETURNED_THIS_PAGE->content_type eq 'text/html') {
				$GET_URL_TYPE =  "html";
			} elsif ($RETURNED_THIS_PAGE->content_type eq 'text/ftp-dir-listing' ){
				$GET_URL_TYPE = "ftp";
			} elsif ($RETURNED_THIS_PAGE->content_type eq 'text/plain' ) {
				$GET_URL_TYPE = "file";
			} else {  $GET_URL_TYPE = "general" ; }
			if ($MY_DEBUG) {print " content type of " . $RETURNED_THIS_PAGE->content_type . " mapped to $GET_URL_TYPE \n";} #JET_DEBUG

#old			if (!defined ($url_data) &&  $GET_URL_TYPE eq "ftp" ) {
#old				$get_this_url_2 = $GET_THIS_URL;
#old				$get_this_url_2 =~ s/\//\%2F/g; ## change all / to hex value, but ftp://xx/ get changed too.
#old				$get_this_url_2 =~ s/\%2F/\//; ## change to ftp:/%2Fxx%2F get changed too.
#old				$get_this_url_2 =~ s/\%2F/\//; ## change to ftp://xx%2F get changed too.
#old				$get_this_url_2 =~ s/\%2F/\//; ## change to ftp://xx/ get changed too.
#old	if ($MY_DEBUG) { print "*******\n******** URL undefined, retry as $get_this_url_2\n***********\n";} #JET_DEBUG
#old				$url_data = get $get_this_url_2;
#old			}
			if ($GET_URL_TYPE eq "ftp" | $GET_URL_TYPE eq "general" | $GET_URL_TYPE eq "file" ) { ## split early if no want html.
				@lines_to_search = split ('\n',$url_data);
			}
			find_newest(); ## answer returned in  $FIND_NEWEST_ANS
		}
	}
	
	if ($MY_DEBUG) { print "Current ver " . Dumper($CURRENT_VERSION); print "\n";} #JET_DEBUG
	if ($MY_DEBUG) { print "find newest answer \n " . Dumper(%FIND_NEWEST_ANS); print "\n";} #JET_DEBUG
	if ($MY_DEBUG) { print "newest file name is  " .  $FIND_NEWEST_ANS{"filename"}->[0]  . "\n";} #JET_DEBUG
	if ($MY_DEBUG) { print "newest URL  name is  " .  $FIND_NEWEST_ANS{"new_url"}  . "\n";} #JET_DEBUG
## from above	$OUTPUT_CURRENT_FILE =  $CURRENT_VERSION;
	$OUTPUT_NEW_FILE = $FIND_NEWEST_ANS{"filename"}->[0];
	$OUTPUT_NEW_URL = $FIND_NEWEST_ANS{"new_url"} ;
	if ($FIND_NEWEST_ANS{'found_cnt'} > 0 ) {
		if ($FIND_NEWEST_ANS{'version'} gt $CURRENT_VERSION ) {
			print "Local version $OUTPUT_CURRENT_FILE older than $OUTPUT_NEW_FILE at $OUTPUT_NEW_URL\n";
			if ( $GET_FILE || $GET_NEW_FILE_ONLY ) {
				if ($MY_DEBUG) { print " found newer file - going to download now. " . $FIND_NEWEST_ANS{"filename"}->[0] . "\n";} #JET_DEBUG
				if ( $FIND_NEWEST_ANS{"filename"}->[0] ne $FIND_NEWEST_ANS{'new_url'} ) { #JET_DEBUG
					print " Getting " .  $FIND_NEWEST_ANS{'new_url'}. "\n" ; #JET_DEBUG
				} #JET_DEBUG
					$Actual_file_to_get = $FIND_NEWEST_ANS{'new_url'};
##only if ftp				if (substr($FIND_NEWEST_ANS{'new_url'},-1,1) ne "/" ) {
##only if ftp					$Actual_file_to_get = $FIND_NEWEST_ANS{'new_url'} . "/" .  $FIND_NEWEST_ANS{"filename"}->[0];
##only if ftp				} else {
##only if ftp					$Actual_file_to_get = $FIND_NEWEST_ANS{'new_url'} .  $FIND_NEWEST_ANS{"filename"}->[0];
##only if ftp				}
				if ($GET_URL_TYPE eq "file" ) { ##  if really a file, make sure no trailing / 
					if ($MY_DEBUG) {print "\n      URL is specified as  a file, drop last *FILE* name\n";} #JET_DEBUG
					if (substr($Actual_file_to_get,-1,1) eq "/" ) {
						$Actual_file_to_get = substr($Actual_file_to_get,0,-1);
						if ($MY_DEBUG) {print "\n      Extra / - del it\n";} #JET_DEBUG
					}
				}

				Get_File_Now($Actual_file_to_get, $FIND_NEWEST_ANS{"filename"}->[0]);
			} else {
				if ($VERBOSE) {
					print "\n      Newer entry found: " .  $FIND_NEWEST_ANS{"filename"}->[0] ;
					if ( $FIND_NEWEST_ANS{"filename"}->[0] ne $FIND_NEWEST_ANS{'new_url'} ) {
						print " at " .  $FIND_NEWEST_ANS{'new_url'} . "\n";
					}
					print "\n";
					for ($i=1; $i<$FIND_NEWEST_ANS{'found_cnt'} ; $i++) {
						print  "                         " . $FIND_NEWEST_ANS{"filename"}->[$i] . "\n";;
					}
				}
			}
		} else { 
			if ($FIND_NEWEST_ANS{'version'} eq $CURRENT_VERSION ) {
				print "Local version $OUTPUT_CURRENT_FILE same as    $OUTPUT_NEW_FILE at $OUTPUT_NEW_URL\n";
			} else {
				print "Local version $OUTPUT_CURRENT_FILE newer than $OUTPUT_NEW_FILE at $OUTPUT_NEW_URL\n";
				}
			if ($MY_DEBUG) {  #JET_DEBUG
				print "\n      NO Newer entry found: " .  $FIND_NEWEST_ANS{"filename"}->[0] . "\n"; #JET_DEBUG
				print   " current ver $CURRENT_VERSION \n" .  #JET_DEBUG
					"  latest ver " . $FIND_NEWEST_ANS{'version'} . " \n"; #JET_DEBUG
				for ($i=1; $i<$FIND_NEWEST_ANS{'found_cnt'} ; $i++) { #JET_DEBUG
					print  "                         " . $FIND_NEWEST_ANS{"filename"}->[$i] . "\n";; #JET_DEBUG
					} #JET_DEBUG
				} #JET_DEBUG
			if ( $GET_FILE && !$GET_NEW_FILE_ONLY ) {
				$Actual_file_to_get = $FIND_NEWEST_ANS{'new_url'};
				print "\n  Get any file, not just newer specified. Found same file version\n   Getting $Actual_file_to_get\n"; #JET_DEBUG
##only if ftp				if (substr($FIND_NEWEST_ANS{'new_url'},-1,1) ne "/" ) {
##only if ftp					$Actual_file_to_get = $FIND_NEWEST_ANS{'new_url'} . "/" .  $FIND_NEWEST_ANS{"filename"}->[0];
##only if ftp				} else {
##only if ftp					$Actual_file_to_get = $FIND_NEWEST_ANS{'new_url'} .  $FIND_NEWEST_ANS{"filename"}->[0];
##only if ftp				}
				if ($GET_URL_TYPE eq "file" ) { ##  if really a file, make sure no trailing / 
					if ($MY_DEBUG) {print "\n      URL is specified as  a file, drop last *FILE* name\n";} #JET_DEBUG
					if (substr($Actual_file_to_get,-1,1) eq "/" ) {
						$Actual_file_to_get = substr($Actual_file_to_get,0,-1);
						if ($MY_DEBUG) {print "\n      Extra / - del it\n";} #JET_DEBUG
					}
				}
				Get_File_Now($Actual_file_to_get, $FIND_NEWEST_ANS{"filename"}->[0]);

			}
		}
	} else {
		print "Local version $OUTPUT_CURRENT_FILE - not found on server.\n";
	}
	
} ## end of sub execute_search



###
###  sub to actually go out and get the page and look for newest.
###  returns structure with newest version num, number of files found
###  (> 1 if we use @TZ@) and file name(s)
###
###   RETURNS DATA IN GLOBAL FIND_NEWEST_ANS
###

sub find_newest() {
if ($MY_DEBUG) { print "\n\n   >>> enter sub find_newest\n";} #JET_DEBUG

## see if we use the @URL@ tag in pattern. IF so , set flag and delete tag.

$USE_ANCHOR_URL=0;  ##default - no url searching, just text description
$USE_ANCHOR_TEXT=1;  ##default - no url searching, just text description
if (substr($PAT,0,5) eq '@URL@') {  ##we actally want url searching
	if ($MY_DEBUG) { print "\@URL\@ tag found in pattern " . $PAT  ;} #JET_DEBUG
	substr($PAT,0,5) = "";
	if ($MY_DEBUG) { print "  Change pattern to " . $PAT . "\n";} #JET_DEBUG
	$USE_ANCHOR_URL=1;
	$USE_ANCHOR_TEXT=0;
} elsif (substr($PAT,0,6) eq '@URL+@') { ## we dont know what we want. Do it all.
	if ($MY_DEBUG) { print "\@URL+\@ tag found in pattern " . $PAT  ;} #JET_DEBUG
	substr($PAT,0,6) = "";
	if ($MY_DEBUG) { print "  Change pattern to " . $PAT . "\n";} #JET_DEBUG
	$USE_ANCHOR_URL=1;
	$USE_ANCHOR_TEXT=1;
}
	else { if ($MY_DEBUG >1 ) {print " NO \@URL\@ in " . $PAT  . " does not match ->" . substr($PAT,0,5) .  "<-\n";}} #JET_DEBUG

if ($MY_DEBUG) { print "\n\nChecking pattern $PAT\n";} #JET_DEBUG
if ($MY_DEBUG>1) { print "\n\nChecking " . substr($PAT,-4)  . " for global archive/compress\n";} #JET_DEBUG

if (substr($PAT,-4) eq '@TZ@' ) {
if ($MY_DEBUG>1) { print "Pattern " . substr($PAT,-4)  . " SHOWS MULTIPAT\n";} #JET_DEBUG
	$MULTIPAT=1;
	$PAT=substr ($PAT,0, -4);
	if ( $PAT =~ /.*@.*/) {  ## look for constant
		$PRESCAN = $PAT;
		$MIDSCAN = $PAT;
		$POSTSCAN = $PAT; #postscan preceeds final multipat
		$POSTSCAN =~ s/.*\@.*@//;  ## do not end in $ as we append TZ patterns later
		$POSTSCAN =~  s/\./\\\./g; #escape periods
		$POSTSCAN =~  s/\+/\\\+/g; #escape plus signs  (gtk+)
	} else {
		$PRESCAN = "";
		$MIDSCAN = $PAT; ## must be here as version pat.
		$POSTSCAN = "";
	}
		
}else{ 
if ($MY_DEBUG>1) { print "Pattern " . substr($PAT,-4)  . " does not show multpat\n";} #JET_DEBUG
	$MULTIPAT=0;
	if ( $PAT =~ /.*@.*/) {  ## look for constant
		$PRESCAN = $PAT;
		$MIDSCAN = $PAT;
		$POSTSCAN = $PAT;
		$POSTSCAN =~ s/.*\@.*@//; $POSTSCAN =~ s/$/\$/;
		$POSTSCAN =~  s/\./\\\./g; #escape periods
		$POSTSCAN =~  s/\+/\\\+/g; #escape plus signs  (gtk+)
	} else {
		$PRESCAN = "";
		$MIDSCAN = $PAT; ## must be here as version pat.
		$POSTSCAN = '$';
	}
} 
if ($MY_DEBUG>1) { print "   PRESCAN starts with $PRESCAN \n";} #JET_DEBUG
if ($MY_DEBUG>1) { print "   MIDSCAN starts with $MIDSCAN \n";} #JET_DEBUG
if ($MY_DEBUG>1) { print "   POSTSCAN starts with $POSTSCAN \n";} #JET_DEBUG

$PRESCAN =~ s/\@.*//; $PRESCAN =~ s/^/\^/; 
$PRESCAN =~ s/\./\\\./g; #escape periods
$PRESCAN =~ s/\+/\\\+/g; #escape plus signs  (gtk+)
## now, prescan has to account for paths and url stuff if we use @URL@ pattern, so 
## do it here. If not html and still specified, use did a nono.
## OLD WAY - NOW WE DO THIS IN ACUTAL HTML SCAN AREA
#if ($USE_ANCHOR_URL) {
#	if ($MY_DEBUG) {print " \@URL\@ found, old PRESCAN is -> $PRESCAN\n ";} #JET_DEBUG
#	$PRESCAN=~ s/./^.*\// ; # replace leading ^ with .*/
#}

$MIDSCAN =~ s/[^@]*\@//; ##drop leading stuff to middle pattern - DO NOT CHANGE USERS PATTERN DEF
$MIDSCAN =~ s/\@.*//;  ## drop stuff after middle pattern - DO NOT CHANGE USERS PATTERN DEF
if    ($MIDSCAN eq "=") {$MIDSCAN = '[0-9].*';}  	## empty pattern, replace with standard match
elsif ($MIDSCAN eq "==") {$MIDSCAN = '([0-9].*)*[0-9]';}  	## empty pattern, replace with standard match
elsif ($MIDSCAN eq "##") {$MIDSCAN = '[0-9][-._0-9]*[0-9]';}  	## empty pattern, replace with standard match
elsif ($MIDSCAN eq "==A") {$MIDSCAN = '([0-9].*)*[0-9][a-zA-Z]?';}  	## empty pattern, replace with standard match
elsif ($MIDSCAN eq "")  {$MIDSCAN = '.*';}		## parm of =, total wild card.
  
$ALLSCAN = $PRESCAN . $MIDSCAN . $POSTSCAN;

if ($MY_DEBUG) { #JET_DEBUG
	print " PRESCAN pattern is ->"; #JET_DEBUG
	for ($i=0;$i<=length($PRESCAN); $i++) { print substr($PRESCAN,$i,1);} #JET_DEBUG
	print "<-- \n\n"; #JET_DEBUG
 					#JET_DEBUG
	print " POSTSCAN pattern is ->"; #JET_DEBUG
	for ($i=0;$i<=length($POSTSCAN); $i++) { print substr($POSTSCAN,$i,1);} #JET_DEBUG
	print "<-- \n\n"; #JET_DEBUG
 					#JET_DEBUG
	print " MIDSCAN pattern is ->"; #JET_DEBUG
	for ($i=0;$i<=length($MIDSCAN); $i++) { print substr($MIDSCAN,$i,1);} #JET_DEBUG
	print "<-- \n\n"; #JET_DEBUG
 					#JET_DEBUG
	print " ALLSCAN pattern is ->"; #JET_DEBUG
	for ($i=0;$i<=length($ALLSCAN); $i++) { print substr($ALLSCAN,$i,1);} #JET_DEBUG
	print "<-- \n\n"; #JET_DEBUG
 					#JET_DEBUG
	if ($MULTIPAT) { print "MIDSCAN and ALLSCAN patterns are base on general archive/compress suffixes\n\n";} #JET_DEBUG
	else           { print "MIDSCAN and ALLSCAN patterns IGNORE MULTIPAT.\n\n";} #JET_DEBUG
 					#JET_DEBUG
} #JET_DEBUG

$FOUND_CNT=0;		## number of lines found that match pattern.
$PLACES_PER_LEVEL = 9;     ##such as 2009/01/01 and letter sufffix.
$NUMBER_FILLER = "0000000000000000000";    ##leading filler in levels - need to be min length of $PLACES_PER_LEVEL
$ALPHA_FILLER = "                   ";    ##leading filler in levels - need to be min length of $PLACES_PER_LEVEL

$LARGEST_VERSION = "";
$LARGEST_VERSION_LEVEL = substr($ALPHA_FILLER,0,$PLACES_PER_LEVEL);

$FIND_NEWEST_ANS{'version'}=substr($ALPHA_FILLER,0,$PLACES_PER_LEVEL);
$FIND_NEWEST_ANS{'found_cnt'}=0;

###
### major split in how we search here. 
###  html uses perl modules to break up the page into usable chunks.
###  general and ftp use white space and lines, with ftp assuming only last column, or -> softlink putting file in col n-2
###  is usable. Directory listings assume ftp format. So, html is the odd man out.for now.
###

if ($GET_URL_TYPE eq "html" ) {
	if ($MY_DEBUG) {print "Process data as type HTML... \n";} #JET_DEBUG 
	if ($MY_DEBUG > 3) {print " from ==> " . Dumper($url_data) . "\n";} #JET_DEBUG 

	$pointer_to_html = HTML::TokeParser->new(\$url_data) ;
	while (my $token = $pointer_to_html->get_tag("a")) {
		$FOUND_RELATIVE_URL = $token->[1]{href} || "-";
		$URL_FOR_CHECK_TOKEN = URI->new_abs( $FOUND_RELATIVE_URL, $RETURNED_THIS_PAGE->base ) ;
		if ($MY_DEBUG) {print " URL we would want to get is "  .  $URL_FOR_CHECK_TOKEN . "\n";} #JET_DEBUG
		my $found_text = $pointer_to_html->get_trimmed_text("/a");
		if ($MY_DEBUG > 2) { print "testing RELATIVE_URL=$FOUND_RELATIVE_URL\t text=$found_text\n";} #JET_DEBUG
		if ($USE_ANCHOR_URL) {
			if ($MY_DEBUG > 2) { print "testing URL=$FOUND_RELATIVE_URL\n";} #JET_DEBUG
			$My_check_url = $FOUND_RELATIVE_URL;
			$My_check_url =~ s/.*\///; ## drop all upto and include last / (if any)
			if (check_for_newer_token($My_check_url) ) { ## check url part for match
				if ($MY_DEBUG > 2) { print "newer token returned " . $URL_FOR_CHECK_TOKEN  . "\n";} #JET_DEBUG
			}
		} 
		if ($USE_ANCHOR_TEXT) { ## oops.check same token twice sometimes if we check both...
			if ($MY_DEBUG > 2) { print "testing text=$found_text\n";} #JET_DEBUG
				if (check_for_newer_token($found_text) ) { ## and check verbage for match.
					if ($MY_DEBUG > 2) { print "FOUND_URL   from text = $found_text " . $URL_FOR_CHECK_TOKEN  . "\n";} #JET_DEBUG
9			}
		}
	}
	return();
} ## end of html

###
### check local_ls type inputs here from  ls lists... n
###

if ( $GET_URL_TYPE eq "local_ls") {
	if ($MY_DEBUG) {print "$GET_URL_TYPE is the url type. Go with type other for $#lines_to_search lines\n";} #JET_DEBUG
	foreach $line (@lines_to_search) {
		chomp;
		$FOUND_URL=$GET_THIS_URL; ## -remember this is faking it
		if ($MY_DEBUG) {print "Process data in $line\n";} #JET_DEBUG
		$line =~ s/<[^>]*>//g;  ## drop tag from html
		if ($MY_DEBUG) {print "   line after dropped html tag is  $line\n";} #JET_DEBUG
		@words =split(' ',$line);
		$URL_FOR_CHECK_TOKEN =  $words[$#words]; ## no real url, just file name
		if ($MY_DEBUG) {print " URL we would want to get is "  .  $URL_FOR_CHECK_TOKEN . "\n";} #JET_DEBUG
		if ($words[$#words-1] eq "->" ) { ## link to another place. Linked to is wanted for next url.
			if ($MY_DEBUG) {print "FTP data with link. dropping last 2 tokens in line of \n";} #JET_DEBUG
			if ($MY_DEBUG) {print "    " .  $words[$#words-1] . "  and  " .  $words[$#words] . "\n";} #JET_DEBUG
			$URL_FOR_CHECK_TOKEN = URI->new_abs( $words[$#words-2], $RETURNED_THIS_PAGE->base ) ;
			if ($MY_DEBUG) {print " URL we would want to get is "  .  $URL_FOR_CHECK_TOKEN . "\n";} #JET_DEBUG
			my $temp_n = $#words;
			$#words = $temp_n-2;
		}
		@words = ( $words[$#words]);
		
		foreach $check_word  (@words) {
			if ($MY_DEBUG > 1) {print "Process word " . $check_word . "\n";} #JET_DEBUG
			if (check_for_newer_token($check_word) ) { ## and check verbage for match.
				if ($MY_DEBUG > 2) { print "found match " . $URL_FOR_CHECK_TOKEN . "\n";} #JET_DEBUG
			}
		}
	}
	return(0);
}


###
### check ftp type inputs here. oops, also do ls lists... 
###

if ($GET_URL_TYPE eq "ftp" ) {
	if ($MY_DEBUG) {print "$GET_URL_TYPE is the url type found at $GET_THIS_URL. \n Go with type ftp for $#lines_to_search lines\n";} #JET_DEBUG
	$first_line = 1; ## flag to get first line and check if ftp for leading word of total or Total or TOTAL
	foreach $line (@lines_to_search) {
		chomp;
		$FOUND_URL=$GET_THIS_URL; ## -keep this until we are sure we can delete.
		if ($MY_DEBUG) {print "Process data in $line\n";} #JET_DEBUG
		$line =~ s/<[^>]*>//g;  ## drop tag from html
		if ($MY_DEBUG) {print "   line after dropped html tag is  $line\n";} #JET_DEBUG
		@words =split(' ',$line);
		if ($first_line &&  ( $words[0] eq "total" ||  $words[0] eq "Total" || $words[0] eq "TOTAL" )) {
			if ($MY_DEBUG) {print "FTP data - total line detected - skipping!\n";} #JET_DEBUG
			next;
		}
		$first_line = 0;
		## ftp needs dir to ADD subdir to, or it replaces current subdir - drat.
		$URL_FOR_CHECK_TOKEN = URI->new_abs( $words[$#words], $RETURNED_THIS_PAGE->base . "/" ) ;
		if ($MY_DEBUG) {print " URL we would want to get is "  .  $URL_FOR_CHECK_TOKEN . "\n";} #JET_DEBUG
		if ($MY_DEBUG) {print "   Made from " . $words[$#words] . " added to " .  $RETURNED_THIS_PAGE->base . "\n";} #JET_DEBUG
		if ($words[$#words-1] eq "->" ) { ## link to another place. Linked to is wanted for next url.
			if ($MY_DEBUG) {print "FTP data with link. dropping last 2 tokens in line of \n";} #JET_DEBUG
			if ($MY_DEBUG) {print "    " .  $words[$#words-1] . "  and  " .  $words[$#words] . "\n";} #JET_DEBUG
			$URL_FOR_CHECK_TOKEN = URI->new_abs( $words[$#words-2], $RETURNED_THIS_PAGE->base ) ;
			if ($MY_DEBUG) {print " URL we would want to get is "  .  $URL_FOR_CHECK_TOKEN . "\n";} #JET_DEBUG
			my $temp_n = $#words;
			$#words = $temp_n-2;
		}
		@words = ( $words[$#words]);
		
		foreach $check_word  (@words) {
			if ($MY_DEBUG > 1) {print "Process word " . $check_word . "\n";} #JET_DEBUG
			if (check_for_newer_token($check_word) ) { ## and check verbage for match.
				if ($MY_DEBUG > 2) { print "found match " . $URL_FOR_CHECK_TOKEN . "\n";} #JET_DEBUG
			}
		}
	}
	return(0);
}


###
### check other local (ie file, non url reachable,...)
###

if ($GET_URL_TYPE eq "local_other" ) {
	if ($MY_DEBUG) {print "$GET_URL_TYPE is the url type. Go with type other for $#lines_to_search lines\n";} #JET_DEBUG
##	$URL_FOR_CHECK_TOKEN = URI->new_abs( $words[$#words-1], $RETURNED_THIS_PAGE->base ) ;
	if ($MY_DEBUG) {print " URL we would want to get (this page) is "  .  $URL_FOR_CHECK_TOKEN . "\n";} #JET_DEBUG
	foreach $line (@lines_to_search) {
		chomp;
		$FOUND_URL=$GET_THIS_URL; ## -remember this is faking it
		if ($MY_DEBUG) {print "Process data in $line\n";} #JET_DEBUG
		@words =split(' ',$line);
		foreach $check_word  (@words) {
			if ($MY_DEBUG > 1) {print "Process word " . $check_word . "\n";} #JET_DEBUG
			if (check_for_newer_token($check_word) ) { ## and check verbage for match.
				if ($MY_DEBUG > 2) { print "found match " . $URL_FOR_CHECK_TOKEN . "\n";} #JET_DEBUG
			}
		}
	}
	return(0);
}


###
### check non-html, non-ftp type inputs (ie, other) here. must really just want this page. 
### for now, url we want to get is url of this actual page.
###  hmm.. need to add specific check on gopher sometime...
###

if ($MY_DEBUG) {print "URL type $GET_URL_TYPE - Go with type other for $#lines_to_search lines\n";} #JET_DEBUG
#$URL_FOR_CHECK_TOKEN = URI->new_abs( $words[$#words-1], $RETURNED_THIS_PAGE->base ) ;
$URL_FOR_CHECK_TOKEN = $RETURNED_THIS_PAGE->base ;
if ($MY_DEBUG) {print " URL we would want to get (this page) is "  .  $URL_FOR_CHECK_TOKEN . "\n";} #JET_DEBUG
#if ($MY_DEBUG) {print "     created from " . $words[$#words-1] . " added to " . $RETURNED_THIS_PAGE->base . "\n";} #JET_DEBUG
foreach $line (@lines_to_search) {
	chomp;
	$FOUND_URL=$URL_FOR_CHECK_TOKEN; ## no url to find as this is not html. - drop this line when sure we do not use
	if ($MY_DEBUG) {print "Process data in $line\n";} #JET_DEBUG
## not html....	$line =~ s/<[^>]*>//g;  ## drop tag from html
## not html....	if ($MY_DEBUG) {print "   line after dropped html tag is  $line\n";} #JET_DEBUG
	@words =split(' ',$line);
	foreach $check_word  (@words) {
		if ($MY_DEBUG > 1) {print "Process word " . $check_word . "\n";} #JET_DEBUG
		if (check_for_newer_token($check_word) ) { ## and check verbage for match.
			if ($MY_DEBUG > 2) { print "found match " . $URL_FOR_CHECK_TOKEN . "\n";} #JET_DEBUG
		}
	}
}

}  ## end sub  find_newest

sub print_help() {
	print "  command syntax is:  [options] current_ver url url_type [directory_pat] program_pat\n";
	print "                 or:  -i input_file [-dir source_directory] [check_pattern]\n";
	print "  \n";
	print "     options -   -help, -h = this message\n";
	print "                 -nobeta  = ignore all files with \"beta\" in version number\n";
	print "                 -noalpha = ignore all files with \"alpha\" in version number\n";
 	print "     current_ver - the name of the file last downloaded. used by program to\n";
	print "			  determine if there is a newer version.\n";
	print "			OR specify '@' followed by directory current file is in.\n";
	print "     url - url of ftp site, web page etc. Sites generating a display of \n";
	print "           a directory must end in /.  Use @ to specify a version number\n";
	print "		  that is expected to be found in directory tree.\n";
	print "     url_type -  ftp - expect an ftp format list with name as last field.\n";
	print "                 general - web page format, odd ftp lists, etc.\n";
	print "	    directory_pat - format of directory name denoting where to find version no.\n";
	print "	    program_pat - format of program name denoting where to find version no.\n";
	print " \n";
	print "     If option is -i or -inputfile, the next parameters is assumed to be a text\n";
	print "         file with the specifications normally found on the command line.\n";
	print "         A secondary option of -dir DIRECTORY causes the program to override the \n";
	print "         source directory specified in the input file and uses DIRECTORY instead.\n";
	print "         A final option is assumed to be a tag used to match lines in the input file\n";
	print "         to allow checking of one or a few specific programs for updates. \n";
	print " \n";
	print "   patterns are specified as constant text with variable version information\n";
	print "          denoted by 2 \"@\" in the field. Regex expressions may be specified\n";
	print "		 between the @ signs to further restrict directories examine.\n";
	print "		 The string  @@  signifies a version that starts with any character.\n";
	print "		 The string  @=@  signifies a version that must start with a digit.\n";
	print "		 The string  @==@  signifies a version that must start and end with a digit, or be a single digit.\n";
	print "		 The string  @==A@  signifies a version that must start a digit.\n";
	print "		                    and end with a digit, or a digit followed by a letter,\n";
	print "		                    or be a single digit followed by a letter.\n";
	print "          example - ftp://ftp.badserver.net/put/pgm/'@.*[24680]@'/ to examine only\n";
	print "		   even releases.\n";
	print " \n";
	print " examples:\n";
	print "   ./jetver    jetver-1.24.tar.gz ftp://ftp.badserver.net/put/jetver/1.0/ ftp jetver-@@.tar.gz\n";
	print "   ./jetver    @/usr/local/src/ ftp://ftp.badserver.net/put/jetver/1.0/ ftp jetver-@@.tar.gz\n";
	print "   ./jetver    @/usr/local/src/ ftp://ftp.badserver.net/put/jetver/@/ ftp @@ jetver-@@.tar.gz\n";
	print "   ./jetver    -i /usr/local/src/jetver/example-software-index jetver\n";

}


##
### sub controls comparisons. if no match, see if check word ends in
###  / and if so drop / and retry.
###
###	actual new answer returned via global	$FIND_NEWEST_ANS
###   return code true/false if found/not found
##

sub check_for_newer_token() {
	if ($MY_DEBUG) { print "\n\n   >>> enter sub check_for_newer_token \n";} #JET_DEBUG
	(my $token_to_check)=@_;
	my $tf_to_return=0;
	if ($MY_DEBUG > 1) {print "  Next token is $token_to_check \n";} #JET_DEBUG

	$tf_to_return =  actual_check_for_newer_token($token_to_check); ## check actual token one to one
	if (! $tf_to_return ) { ##oops, no match. see if token ends in /. if so, retry without slash
		if (substr( $token_to_check, -1, 1) eq "/" && $DROP_TRAILING_SLASH) {
			if ($MY_DEBUG > 1) {print "  no match. drop trailig slash and retry \n";} #JET_DEBUG
			chop ( $token_to_check );
			$tf_to_return =  actual_check_for_newer_token($token_to_check); ##  retry
		}
	}
	return ($tf_to_return);
}
 
	

##
### sub that does actual comparison of version numbers. 
### input is token to check.
### globals for patterns, current largest ver number.
###  returns true or false; set globals....
###			$FIND_NEWEST_ANS
##
### expect to find url that gets the next linkfor this token
### in global $URL_FOR_CHECK_TOKEN
##

sub actual_check_for_newer_token() {
if ($MY_DEBUG) { print "\n\n   >>> enter sub actual_check_for_newer_token \n";} #JET_DEBUG
(my $token_to_check)=@_;
my $tf_to_return=0;
if ($MY_DEBUG > 1) {print "    checking token $token_to_check \n";} #JET_DEBUG

##
## check for pattern match
##

my $hold_post_scan = $POSTSCAN;
my $check_scan_matched=0;
if($MULTIPAT) {
	foreach my $endpat ( @suffixes_all_match){
		$ALLSCANMULTI = $ALLSCAN . $endpat;
		if ($MY_DEBUG > 2) {print " ........ multipat checking $ALLSCANMULTI \n";} #JET_DEBUG
		if ( $token_to_check =~ /$ALLSCANMULTI/ ) {
			$check_scan_matched=1;
			$POSTSCAN=$hold_post_scan . $endpat;
			if ($MY_DEBUG > 1) {print "MULTIPAT check matches on pat  $ALLSCANMULTI \n";} #JET_DEBUG
			last;}
	}
} else {
	if ( $token_to_check =~ /$ALLSCAN/ ) {
		if ($MY_DEBUG > 1) {print "ALLSCAN check matches  - pat matches by default \n";} #JET_DEBUG
		$check_scan_matched=1;}
}


if ( ! $check_scan_matched) { ## no match. quit.
	$POSTSCAN = $hold_post_scan; ## reset the post scan in case of multimatch. need to fix this better.
	if ($MY_DEBUG > 1) {print "          token -->" . $token_to_check . "<-- fails to match pattern $ALLSCAN\n";} #JET_DEBUG
	return($tf_to_return);
}


##
## if match,skip alpha/beta etc types if not wanted,
##

if ($MY_DEBUG) {print "Now checking $token_to_check for new version. \n";} #JET_DEBUG
if ($NOBETA && $token_to_check =~ /beta/i) {
	$check_scan_matched=0;
	if ($MY_DEBUG > 1) {print " skipping because it is beta \n";} #JET_DEBUG
	return($tf_to_return);
}
if ($NOALPHA && $token_to_check =~ /alpha/i) {
	$check_scan_matched=0;
	if ($MY_DEBUG > 1) {print " skipping because it is alpha \n";} #JET_DEBUG
	return($tf_to_return);
}

##
## if ok, break out version number
##

my $my_ver = $token_to_check;	
$my_ver =~ s/$PRESCAN//;
if ($PRESCAN eq '^' && $POSTSCAN eq '$') {
	if ($MY_DEBUG) {print "   no version pattern found - assume entire name is version version. \n";} #JET_DEBUG
	@my_ver_split_levels =split('([0-9]+)',$my_ver);
} else {
	if ($MY_DEBUG) {print "after PRESCAN removal of $PRESCAN, check $my_ver \n";} #JET_DEBUG
	$my_ver =~ s/$POSTSCAN//;
	if ($MY_DEBUG) {print "after POSTSCAN removal of $POSTSCAN, check $my_ver \n";} #JET_DEBUG
	if ($MY_DEBUG) {print "found match of  " .  $token_to_check . " with version " .  $my_ver . " \n";} #JET_DEBUG
	@my_ver_split_levels =split('([0-9]+)',$my_ver);
}
my $new_check_level = "";
for (my $i=0;$i<=$#my_ver_split_levels; $i++) {
	if ($MY_DEBUG>1) {print "         -- adding level " . $my_ver_split_levels[$i] . " to " .  $new_check_level . " \n";} #JET_DEBUG
	if ( $my_ver_split_levels[$i] =~ '[0-9]+') { ## numeric fill- 0 at start of string.
		$new_check_level = $new_check_level . substr(($NUMBER_FILLER . $my_ver_split_levels[$i]), -$PLACES_PER_LEVEL);
	} else { ## alpha fill - spaces at end of string.
		$new_check_level = $new_check_level . substr(($my_ver_split_levels[$i] . $ALPHA_FILLER), 0,$PLACES_PER_LEVEL);
	}
}
### for now, assume missing levels will take care of themselves...
if ($MY_DEBUG) {print "                                match version = " .  $new_check_level . " \n";} #JET_DEBUG
	


##
##  WE HAVE LARGER VERSION - update  FIND_NEWEST_ANSWER
##


if ( $LARGEST_VERSION lt $new_check_level ) {
	 if ($MY_DEBUG) {print "   *** NEW NEWEST VERSION $new_check_level for $token_to_check\n";} #JET_DEBUG
	 if ($MY_DEBUG) {print "                    for page $URL_FOR_CHECK_TOKEN\n";} #JET_DEBUG
	 if ($MY_DEBUG) {print "                    from base $GET_THIS_URL\n";} #JET_DEBUG
	$GET_THIS_URL =  URI->new($GET_THIS_URL);
if ( $MY_DEBUG > 1) {print " dumper of FOUND_URL (do not use)\n" . Dumper($FOUND_URL); print "\n\n";} #JET_DEBUG
if ( $MY_DEBUG > 1) {print " dumper of URL_FOR_CHECK_TOKEN\n" . Dumper($URL_FOR_CHECK_TOKEN); print "\n\n";} #JET_DEBUG
if ( $MY_DEBUG > 1) {print " dumper of GET_THIS_URL\n" . Dumper($GET_THIS_URL); print "\n\n";} #JET_DEBUG
if ($MY_DEBUG) {print "          scheme for GET_THIS_URL is " . $GET_THIS_URL->scheme . "\n";} #JET_DEBUG
if ($MY_DEBUG) {print "          path for GET_THIS_URL is " . $GET_THIS_URL->path   . "\n";} #JET_DEBUG
if ($MY_DEBUG) {print "          fragment for GET_THIS_URL is " . $GET_THIS_URL->fragment . "\n";} #JET_DEBUG
	$LARGEST_VERSION = $new_check_level;
	$FIND_NEWEST_ANS{'version'}=$new_check_level;
	$FIND_NEWEST_ANS{'found_cnt'}=1;
	$FIND_NEWEST_ANS{'new_url'}=  $URL_FOR_CHECK_TOKEN;
## next obviated by $URL_FOR_CHECK_TOKEN
#	if ($FOUND_URL ne "") {
#		if ( $GET_URL_TYPE eq "ftp")  {
#			if (substr($GET_THIS_URL,-1,1) ne '/') { ## ok, no ending slash. add 1.
#				$GET_THIS_URL = URI->new($GET_THIS_URL->as_string . '/');
#				if ( $MY_DEBUG > 1) {print " adding / to end of ftp\n";} #JET_DEBUG
#			}
#			$FIND_NEWEST_ANS{'new_url'}=  $GET_THIS_URL . $token_to_check;
#			if ( $MY_DEBUG > 1) {print " adding file name to end of ftp\n";} #JET_DEBUG
#		} else {
#			$FIND_NEWEST_ANS{'new_url'}=URI->new_abs( $FOUND_URL, $GET_THIS_URL);
#			if ( $MY_DEBUG > 1) {print " making new http: url\n";} #JET_DEBUG
#		}
#	} else {
#		$FIND_NEWEST_ANS{'new_url'}="";
#	}
if ( $MY_DEBUG > 1) {print " dumper of new_url\n" . Dumper($FIND_NEWEST_ANS{'new_url'}); print "\n\n";} #JET_DEBUG
##	 if ($MY_DEBUG) {print "   ... converted file/page of $FOUND_URL using base $GET_THIS_URL to $FIND_NEWEST_ANS{'new_url'}\n";} #JET_DEBUG
## why did I do this		$FIND_NEWEST_ANS{'new_url'} = $GET_THIS_URL; 
	$FIND_NEWEST_ANS{"filename"}->[0] =$token_to_check;
	$tf_to_return=1;
} elsif ($LARGEST_VERSION eq $new_check_level ) {
##
##  WE HAVE SAME VERSION NUMBER - update  FIND_NEWEST_ANSWER with additional find.
##
	$FIND_NEWEST_ANS{"filename"}->[$FIND_NEWEST_ANS{'found_cnt'}] =$token_to_check;
	$FIND_NEWEST_ANS{'found_cnt'}++;
##
##  SMALLER VERSION NUMBER - no update
##
} else {
	 if ($MY_DEBUG) {print "   *** level $new_check_level of $token_to_check not greater than $LARGEST_VERSION\n";} #JET_DEBUG
}
	

$POSTSCAN = $hold_post_scan; ## reset the post scan in case of multimatch. need to fix this better.
return($tf_to_return);
}



sub Get_File_Now($$) {
if ($MY_DEBUG) { print "\n\n   >>> enter sub Get_File_Now          \n";} #JET_DEBUG
	(my $Get_URL, $Local_Get_name ) = @_;
	if ($MY_DEBUG ) {print "       MY_DEBUG - In Get_File_Now - Fetching file $Get_URL now.\n";} #JET_DEBUG
### old	$file_url = get $Get_URL;
###JET - file_url now has file - ugh

## wget -O FILENAME URL
##	my $Local_Get_name= $GET_FILE_NAME;
	if ( $Local_Get_name eq "") { ## emergency change..
		if ($MY_DEBUG ) {print "      OOPS - local file name empty. Get from URL.\n";} #JET_DEBUG
		$Local_Get_name= substr($Get_URL,rindex($Get_URL,"/")+1);
	}
	if ($MY_DEBUG ) {print "       MY_DEBUG - placing in file name $Local_Get_name now.\n";} #JET_DEBUG
	if (is_error($rc=getstore($Get_URL, $Local_Get_name)) ) {
		print "  ERROR $rc on fetch of $Local_Get_name from $Get_URL\n";
	}

	
	return (0);
}
